<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import InstallDropdown from '~/components/install/install-dropdown.vue';
import CardSection from '~/components/install/card-section.vue';

import { getPageMetadata } from '~/common/meta';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';

export default Vue.extend({
  components: {
    InstallDropdown,
    CardSection,
  },
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData({ $installService }) {
    try {
      const { install, items } = await $installService.getContent('install');

      return {
        doc: install,
        items,
        spaceId: items.sys.space.sys.id,
        entryId: items.sys.id,
      };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      dropdownCard: null,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.$route.hash) {
      this.dropdownCard = this.$route.hash.split('#')[1];
    }

    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: async (updatedData) =>
          (this.doc =
            await this.$installService.transformLandingData(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
  methods: {
    openDropdown(cardId) {
      this.dropdownCard = cardId;
    },
    closeDropdown() {
      this.dropdownCard = null;
      this.$router.push(this.$route.path.split('#'));
    },
  },
});
</script>
<template>
  <div class="install">
    <SlpContainer>
      <SlpSideNavigation :data="doc.side_menu">
        <SlpRow class="row">
          <SlpColumn :cols="10" size="xl">
            <div class="header">
              <SlpTypography tag="h1" variant="heading1-bold"
                >{{ doc.header.title }}
              </SlpTypography>
              <SlpTypography tag="h2" variant="heading3-bold"
                >{{ doc.header.subtitle }}
              </SlpTypography>
              <div
                v-if="doc.header.text"
                class="header__text"
                v-html="$md.render(doc.header.text)"
              />
            </div>
            <!-- Linux and dropdown functionality -->
            <div
              v-if="doc.linux"
              :id="doc.linux.id"
              class="section colored-background"
            >
              <SlpTypography tag="p" class="linux-subtitle" variant="body2"
                >{{ doc.linux.subtitle }}
              </SlpTypography>
              <SlpTypography tag="h2" variant="heading2-bold"
                >{{ doc.linux.title }}
              </SlpTypography>
              <div class="text" v-html="$md.render(doc.linux.text)" />
              <div class="cards">
                <a
                  v-for="card in doc.linux.cards"
                  :key="card.title"
                  :aria-label="`Click for ${card.title} installation instructions`"
                  :href="card.link_url"
                  class="dropdown-card"
                  @click="openDropdown(card.id)"
                >
                  <div class="image-container">
                    <SlpIcon
                      v-if="card.icon.variant"
                      :name="card.icon.name"
                      :alt="card.icon.alt"
                      :variant="card.icon.variant"
                      :hex-color="card.icon.hex_color"
                      size="lg"
                    />
                    <nuxt-img
                      v-if="card.icon && !card.icon.variant"
                      :src="`/nuxt-images/logos/${card.icon.name}.svg`"
                      :alt="card.icon.alt"
                      format="webp"
                      quality="99"
                    />
                  </div>
                  <SlpTypography tag="h3" variant="heading3"
                    >{{ card.title }}
                  </SlpTypography>
                  <SlpTypography tag="p">{{ card.subtext }}</SlpTypography>
                  <span>{{ card.link_text }}</span>
                </a>
              </div>
              <InstallDropdown
                v-for="card in doc.linux.cards"
                v-show="dropdownCard === card.id"
                :id="card.id"
                :key="card.id"
                aria-live="polite"
                :data="card.dropdown"
                @closed="closeDropdown"
              />
            </div>
            <!-- End Linux -->
            <div>
              <CardSection
                v-if="doc.kubernetes"
                :id="doc.kubernetes.id"
                :data="doc.kubernetes"
              />

              <CardSection
                v-if="doc.supported_cloud"
                :id="doc.supported_cloud.id"
                class="colored-background"
                :data="doc.supported_cloud"
              />
              <CardSection
                v-if="doc.official_methods"
                :id="doc.official_methods.id"
                :data="doc.official_methods"
              />
              <CardSection
                v-if="doc.unofficial_methods"
                :id="doc.unofficial_methods.id"
                class="colored-background"
                :data="doc.unofficial_methods"
              />
              <CardSection :id="doc.updates.id" :data="doc.updates" />
            </div>
          </SlpColumn>
        </SlpRow>
      </SlpSideNavigation>
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.install {
  position: relative;

  .slp-container {
    max-width: 1195px;
  }
}

.header {
  margin-top: 40px;
  @media (min-width: $breakpoint-md) {
    margin-top: $spacing-96;
  }

  h1,
  h2 {
    letter-spacing: -0.03em;
  }

  h1 {
    margin-bottom: $spacing-16;
  }

  h2 {
    margin-bottom: $spacing-24;
  }

  .header__text {
    font-size: 20px;

    &:deep p {
      margin: 8px 0;
    }
  }
}

.colored-background {
  background: $color-surface-100;
  width: 100%;
  max-width: 100%;
  position: relative;
  padding: $spacing-64 0;

  box-shadow: 0 0 0 100vmax $color-surface-100;
  clip-path: inset(0 -100vmax);
}

.text:deep {
  font-size: $font-size-default;
  line-height: $line-height-default;

  p {
    margin-bottom: $spacing-8;
  }
}

.section {
  margin: $spacing-64 0;

  h2 {
    margin-bottom: $spacing-16;
  }
}

.linux-subtitle {
  margin-bottom: $spacing-8;
}

.cards {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
  gap: $spacing-16;
  align-items: stretch;
  margin-top: $spacing-48;
}

.dropdown-card {
  flex: 1 0 calc(33% - 16px);
  background: $color-surface-50;
  text-decoration: none;
  display: flex;
  flex-direction: column;
  padding: $spacing-32;
  width: 100%;
  max-width: 320px;
  border-radius: 16px;
  box-shadow: none;
  transition: all 0.3s ease-in-out;
  margin-bottom: $spacing-8;

  &:hover {
    box-shadow: $shadow-surface-primary-3;
  }

  @media (max-width: 820px) {
    // breakpoint at iPad Air width and below
    flex: 0 0 calc(50% - 8px);
    flex-wrap: wrap;
  }

  @media (max-width: $breakpoint-sm) {
    flex: 0 0 100%;
    max-width: 100%;
  }

  h3 {
    margin: $spacing-16 0 $spacing-24 0;
    color: $color-text-300;
  }

  p {
    color: $color-text-300;
    font-size: $font-size-default;
    line-height: $line-height-default;
    margin-bottom: $spacing-24;
  }

  span {
    font-weight: $font-weight-bold;
    color: $color-text-300;
    display: flex;
    align-items: center;

    svg {
      margin-left: 12px;
    }
  }

  .image-container {
    max-width: 50px;
    width: 100%;
    max-height: 50px;
    position: relative;
    height: 50px;

    img {
      height: 100%;
    }
  }
}
</style>
